      program mk_ssc

      open (unit=1,file='invaders-recto.ssc',form='formatted')

      call srand(0)

      call wrt_nbk

      do nlf = 30,0,-1
         call wrt_leaf(nlf)
      enddo

      close (unit=1)
      end


      subroutine wrt_leaf(nlf)
c     write backward from bottom so height can vary
c     don't forget to change order in pages

      data y/-0.12/
      save y
      dy = 0.0005
      y = y + dy
      
      if (nlf.eq.30) then
         call wrt_cv (2,nlf,y)
      else if (nlf.eq.0) then
         call wrt_cv(1,nlf,y)

      else  if (nlf.eq.3) then
         call wrt_div(1,nlf,y)
      else  if (nlf.eq.8) then
         call wrt_div(2,nlf,y)
      else  if (nlf.eq.24) then
         call wrt_div(3,nlf,y)
      else  if (nlf.eq.27) then
         call wrt_div(8,nlf,y)

      else
         call wrt_pg (nlf,y)
      endif

      return
      end


      subroutine wrt_pg(nlf,y)
c      write a page of paper
      save npage

      data npage/52/ !# (must be even) leaves * 2 - 2x*dividers = 29*2-8

      thick = 0.005
      y = y + thick

      write (1,10) '"leaf_',nlf,'_recto" "Sol" {'
 10   format(a,i2.2,a)
      write(1,*) 'Mesh "leaf.cmod"'

      npage = npage-2
      write(1,12) '  Texture "pages_',(npage-1),'-',(npage),'.*"'
 12   format(a,2(i2.2,a))
      
      call wrt_common(nlf,y)

      return
      end
c-----------------------------------------------------
      subroutine wrt_div(nd,nlf,y)
c      write a divider
      save npage
      data npage/0/
         thick = 0.01
         y = y + thick

      write (1,10) '"leaf_',nlf,'_recto" "Sol" {'
 10   format(a,i2.2,a)
      write(1,21) '  Mesh "divider_',nd,'.cmod"'
 21   format(a,i2.2,a)

      call wrt_common(nlf,y)
      return
      end
c=========================
      subroutine  wrt_nbk

c     origin
      write (1,*) '"Notebook" "Sol" {' 
      write (1,*) ' Class "spacecraft"'
      write (1,*) 'Visible false'
      write (1,*) 'Clickable false'
      write (1,*) 'Radius 0.5'
      write (1,*) 'EllipticalOrbit { Period 1 SemiMajorAxis 1.0130001 }'
      write (1,*) 'CustomRotation "earth-p03lp"'
      write (1,*) 'Albedo 1e-32'
      write (1,*) '}'

c==============
      write (1,*) '"notebook_open" "Sol" {'
      write (1,*) ' Class "spacecraft"'
      write (1,*) ' Radius 7'
      write (1,*) 'Planetshine false'
      write (1,*) 'Visible false'
      write (1,*) 'Mesh "notebook_open.cmod"'
      write (1,*) 'NormalizeMesh false'
      write (1,*) 'MeshScale 0.0075'

      write (1,*) 'OrbitFrame { BodyFixed { Center "Sol/Notebook"}}'
      write (1,*) 'FixedPosition [ 0 0 0]'

      write (1,*) 'BodyFrame { BodyFixed  { Center "Sol/Notebook"}}'
      write (1,*) 'FixedRotation {'
      write (1,*) 'Inclination 0'
      write (1,*) 'MeridianAngle 0'
      write (1,*) 'AscendingNode 0'
      write (1,*) '}'
      write (1,*) 'Albedo 1e-32'
      write (1,*) '}'

c......................
      write (1,*) '"spine_mech_closed" "Sol" {'
      write (1,*) ' Class "spacecraft"'
      write (1,*) ' Radius 7'
      write (1,*) 'Planetshine false'
      write (1,*) 'Visible false'
      write (1,*) 'Mesh "spine_mech_closed.cmod"'
      write (1,*) 'NormalizeMesh false'
      write (1,*) 'MeshScale 0.0075'

      write (1,*) 'OrbitFrame { BodyFixed { Center "Sol/Notebook"}}'
      write (1,*) 'FixedPosition [ 0 0 0]'

      write (1,*) 'BodyFrame { BodyFixed  { Center "Sol/Notebook"}}'
      write (1,*) 'FixedRotation {'
      write (1,*) 'Inclination 0'
      write (1,*) 'MeridianAngle 0'
      write (1,*) 'AscendingNode 0'
      write (1,*) '}'
      write (1,*) 'Albedo 1e-32'
      write (1,*) '}'
c......................
      write (1,*) '"spine_mech_open" "Sol" {'
      write (1,*) ' Class "spacecraft"'
      write (1,*) ' Radius 7'
      write (1,*) 'Planetshine false'
      write (1,*) 'Visible false'
      write (1,*) 'Mesh "spine_mech_open.cmod"'
      write (1,*) 'NormalizeMesh false'
      write (1,*) 'MeshScale 0.0075'

      write (1,*) 'OrbitFrame { BodyFixed { Center "Sol/Notebook"}}'
      write (1,*) 'FixedPosition [ 0 0 0]'

      write (1,*) 'BodyFrame { BodyFixed  { Center "Sol/Notebook"}}'
      write (1,*) 'FixedRotation {'
      write (1,*) 'Inclination 0'
      write (1,*) 'MeridianAngle 0'
      write (1,*) 'AscendingNode 0'
      write (1,*) '}'
      write (1,*) 'Albedo 1e-32'
      write (1,*) '}'

c==============
      write (1,*) '"notebook_closed" "Sol" {'
      write (1,*) ' Class "spacecraft"'
      write (1,*) ' Radius 7'
      write (1,*) 'Planetshine false'
      write (1,*) 'Visible false'
      write (1,*) 'Mesh "notebook_closed.cmod"'
      write (1,*) 'NormalizeMesh false'
      write (1,*) 'MeshScale 0.0075'

      write (1,*) 'OrbitFrame { BodyFixed { Center "Sol/Notebook"}}'
      write (1,*) 'FixedPosition [ 0 0 0]'

      write (1,*) 'BodyFrame { BodyFixed  { Center "Sol/Notebook"}}'
      write (1,*) 'FixedRotation {'
      write (1,*) 'Inclination 0'
      write (1,*) 'MeridianAngle 0'
      write (1,*) 'AscendingNode 0'
      write (1,*) '}'
      write (1,*) 'Albedo 1e-32'
      write (1,*) '}'
      return
      end

c------------------------------

      subroutine wrt_cv (ncv,nlf,y)
      thick = 0.015
      y = y + thick

      if (ncv.eq.1) then
         write (1,*) '"front_cover_recto" "Sol" {'
         write (1,*) 'Texture "blue_translucent_cover_scribbled.*"'
      else
         write (1,*) '"back_cover_recto" "Sol" {'
         write (1,*) 'Texture "back_cover.*"'
      endif
      write(1,*) 'Mesh "cover.cmod"'

      call wrt_common(nlf,y)
      return
      end
      
c------------------------------

      subroutine wrt_common(nlf,y)

      write(1,*) '  Radius 4.5'
      write(1,*) '  Planetshine false'
      write(1,*) '  Visible false'

      write(1,*) '  NormalizeMesh false'
      write(1,*) '  MeshScale 0.0075'
      write(1,*) '  OrbitFrame { BodyFixed { Center "Sol/Notebook"}}'

      rz = (ran(0)-0.5)*0.025
      rx = (ran(0)-0.5)*0.025

      z=rz
      x = circle(y)+rx
      
      write(1,11) '  FixedPosition [',x,y,z,']'
 11   format(a,3(f7.3,1x),a)

      write(1,*) '  BodyFrame { BodyFixed  { Center "Sol/Notebook"}}'
      write(1,*) '  FixedRotation {'

      th = (ran(0)-0.5)*0.7

      write (1,13) 'Inclination ',th
      write (1,*) 'MeridianAngle 271.5'
      write (1,*) 'AscendingNode 90'

 13   format(a,f9.3)
      write(1,*) '   }'
      write(1,*) ' Albedo 1e-32'
      write(1,*) ' }'

      return
      end

      function circle(y)
c     return x as a function of y
c     r^2=x^2+y^2
c      x**2=r**2-y**2

      r = 0.3
      ylocal = y - 0.065
      circle= - sqrt(r**2-ylocal**2)
      circle = circle + 0.25
c      print *, y,ylocal,circle

      return
      end
      
